#!/usr/bin/perl
###############################################################################
#                                                                             #
# IPFire.org - A linux based firewall                                         #
# Copyright (C) 2012														  #
#                                                                             #
# This program is free software: you can redistribute it and/or modify        #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation, either version 3 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# This program is distributed in the hope that it will be useful,             #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.       #
#                                                                             #
###############################################################################
#																			  #
# Hi folks! I hope this code is useful for all. I needed something to handle  #
# my VPN Connections in a comfortable way. 				      				  #
# This script builds firewallrules from the webinterface                      #
###############################################################################


use strict;
no warnings 'uninitialized';

# enable only the following on debugging purpose
#use warnings;
#use CGI::Carp 'fatalsToBrowser';

my %fwdfwsettings=();
my %defaultNetworks=();
my %netsettings=();
my %customhost=();
my %customgrp=();
my %customnetworks=();
my %customservice=();
my %customservicegrp=();
my %ccdnet=();
my %customnetwork=();
my %ccdhost=();
my %configfwdfw=();
my %ipsecconf=();
my %color=();
my %mainsettings=();
my %icmptypes=();
my %ovpnSettings=();
my %netsettings=();
my %ipsecsettings=();
our %sourcehash=();
our %targethash=();

my @timeframe=();

require '/var/ipfire/general-functions.pl';
require "${General::swroot}/lang.pl";

my $confignet		= "${General::swroot}/fwhosts/customnetworks";
my $confighost		= "${General::swroot}/fwhosts/customhosts";
my $configgrp 		= "${General::swroot}/fwhosts/customgroups";
my $configsrv 		= "${General::swroot}/fwhosts/customservices";
my $configsrvgrp	= "${General::swroot}/fwhosts/customservicegrp";
my $configccdnet 	= "${General::swroot}/ovpn/ccd.conf";
my $configccdhost	= "${General::swroot}/ovpn/ovpnconfig";
my $configipsec		= "${General::swroot}/vpn/config";
my $configipsecrw	= "${General::swroot}/vpn/settings";
my $configfwdfw		= "${General::swroot}/forward/config";
my $configovpn		= "${General::swroot}/ovpn/settings";
my $errormessage='';
my ($TYPE,$PROT,$SPROT,$DPROT,$SPORT,$DPORT,$TIME,$TIMEFROM,$TIMETILL,$SRC_TGT);
my $CHAIN="FORWARDFW";
&General::readhash("/var/ipfire/ethernet/settings", \%netsettings);
&General::readhash("${General::swroot}/ovpn/settings", \%ovpnSettings);
&General::readhash("${General::swroot}/forward/settings", \%fwdfwsettings);
&General::readhash("${General::swroot}/main/settings", \%mainsettings);
&General::readhash("${General::swroot}/vpn/settings", \%ipsecsettings);
&General::readhasharray($configfwdfw, \%configfwdfw);
&General::readhasharray("$confignet", \%customnetwork);
&General::readhasharray("$confighost", \%customhost);
&General::readhasharray("$configgrp", \%customgrp);
&General::readhasharray("$configccdnet", \%ccdnet);
&General::readhasharray("$configccdhost", \%ccdhost);
&General::readhasharray("$configipsec", \%ipsecconf);
&General::setup_default_networks(\%defaultNetworks);
################################
#    DEBUG/TEST                #
################################
my $MODE=1;     # 0 - normal operation
				# 1 - print configline and rules to console	
				# 
################################		
my $param=shift;

if($param eq 'flush'){
	&flush;
}else{
	&flush;
	&buildrules;
}

sub flush
{
	system ("iptables -F FORWARDFW");
}				
sub buildrules
{
	foreach my $key (sort keys %configfwdfw){
		if($configfwdfw{$key}[2] eq 'ON'){
			#get source ip's
			if ($configfwdfw{$key}[3] eq 'cust_grp_src'){
				foreach my $grp (sort keys %customgrp){
					if($customgrp{$grp}[0] eq $configfwdfw{$key}[4]){
						&get_address($customgrp{$grp}[3],$customgrp{$grp}[2],"src");
					}
				}
			}else{
				&get_address($configfwdfw{$key}[3],$configfwdfw{$key}[4],"src");
			}
			#get target ip's
			if ($configfwdfw{$key}[5] eq 'cust_grp_tgt'){
				foreach my $grp (sort keys %customgrp){
					if($customgrp{$grp}[0] eq $configfwdfw{$key}[6]){
						&get_address($customgrp{$grp}[3],$customgrp{$grp}[2],"tgt");
					}
				}
			}else{
				&get_address($configfwdfw{$key}[5],$configfwdfw{$key}[6],"tgt");
			}
			#get source prot and port
			$SRC_TGT='SRC';
			$SPROT = &get_prot($key);
			$SPORT = &get_port($key);
			$SRC_TGT='';
			#get target prot and port
			$DPROT = &get_prot($key);
			$DPORT = &get_port($key);
			if ($SPROT ne ''){$PROT=$SPROT;}else{$PROT=$DPROT;}
			$PROT="-p $PROT" if ($PROT ne '');
			#get time if defined
			if($configfwdfw{$key}[18] eq 'ON'){
				if($configfwdfw{$key}[19] ne ''){push (@timeframe,"Mon");}
				if($configfwdfw{$key}[20] ne ''){push (@timeframe,"Tue");}
				if($configfwdfw{$key}[21] ne ''){push (@timeframe,"Wed");}
				if($configfwdfw{$key}[22] ne ''){push (@timeframe,"Thu");}
				if($configfwdfw{$key}[23] ne ''){push (@timeframe,"Fri");}
				if($configfwdfw{$key}[24] ne ''){push (@timeframe,"Sat");}
				if($configfwdfw{$key}[25] ne ''){push (@timeframe,"Sun");}
				$TIME=join(",",@timeframe);
				$TIMEFROM="--timestart $configfwdfw{$key}[26] ";
				$TIMETILL="--timestop $configfwdfw{$key}[27] ";
				$TIME="-m time --weekdays $TIME $TIMEFROM $TIMETILL";
			}
					
			if ($MODE eq '1'){	
				print "NR:$key ";
				foreach my $i (0 .. $#{$configfwdfw{$key}}){
					print "$i: $configfwdfw{$key}[$i]  ";
				}
				print "\n";
				print"##################################\n";
				#print rules to console
				foreach my $a (sort keys %sourcehash){
					foreach my $b (sort keys %targethash){
						if ($sourcehash{$a}[0] ne $targethash{$b}[0] && $targethash{$b}[0] ne 'none'){
							if ($configfwdfw{$key}[17] eq 'ON'){
								print "iptables -A $CHAIN $PROT -s $sourcehash{$a}[0] $SPORT -d $targethash{$b}[0]  $DPORT  $TIME  -j LOG\n";
							}
							print "iptables -A $CHAIN $PROT -s $sourcehash{$a}[0] $SPORT -d $targethash{$b}[0]  $DPORT  $TIME  -j $configfwdfw{$key}[0]\n"; 
						}
					}
					print"\n";
				}
			}elsif($MODE eq '0'){
				foreach my $a (sort keys %sourcehash){
					foreach my $b (sort keys %targethash){
						if ($sourcehash{$a}[0] ne $targethash{$b}[0] && $targethash{$b}[0] ne 'none'){
							if ($configfwdfw{$key}[17] eq 'ON'){
								system ("iptables -A $CHAIN $PROT -s $sourcehash{$a}[0] $SPORT -d $targethash{$b}[0]  $DPORT  $TIME  -j LOG");
							}
							system ("iptables -A $CHAIN $PROT -s $sourcehash{$a}[0] $SPORT -d $targethash{$b}[0]  $DPORT  $TIME  -j $configfwdfw{$key}[0]"); 
						}
					}
				}
			}
		}
		%sourcehash=();
		%targethash=();
	}
}
sub get_address
{
	my $base=shift; #source of checking ($configfwdfw{$key}[x] or groupkey
	my $base2=shift;
	my $type=shift; #src or tgt
	my $hash;
	if ($type eq 'src'){
		$hash=\%sourcehash;	
	}else{
		$hash=\%targethash;
	}
	my $key = &General::findhasharraykey($hash);
	if($base eq 'src_addr' || $base eq 'tgt_addr' ){
		$$hash{$key}[0] = $configfwdfw{$key}[4];
	}elsif($base eq 'std_net_src' || $base eq 'std_net_tgt' || $base eq 'Standard Network'){
		$$hash{$key}[0]=&get_std_net_ip($base2);
	}elsif($base eq 'cust_net_src' || $base eq 'cust_net_tgt' || $base eq 'Custom Network'){
		$$hash{$key}[0]=&get_net_ip($base2);
	}elsif($base eq 'cust_host_src' || $base eq 'cust_host_tgt' || $base eq 'Custom Host'){
		$$hash{$key}[0]=&get_host_ip($base2,$type);
	}elsif($base eq 'ovpn_net_src' || $base eq 'ovpn_net_tgt' || $base eq 'OpenVPN static network'){
		$$hash{$key}[0]=&get_ovpn_net_ip($base2,1);
	}elsif($base eq 'ovpn_host_src' ||$base eq 'ovpn_host_tgt' || $base eq 'OpenVPN static host'){
		$$hash{$key}[0]=&get_ovpn_host_ip($base2,33);
	}elsif($base eq 'ovpn_n2n_src' ||$base eq 'ovpn_n2n_tgt' || $base eq 'OpenVPN N-2-N'){
		$$hash{$key}[0]=&get_ovpn_n2n_ip($base2,27);
	}elsif($base eq 'ipsec_net_src' || $base eq 'ipsec_net_src' || $base eq 'IpSec Network'){
		$$hash{$key}[0]=&get_ipsec_net_ip($base2,11);
	}
}
sub get_prot
{
	my $key=shift;
	if ($configfwdfw{$key}[7] eq 'ON' && $SRC_TGT eq 'SRC'){
		if ($configfwdfw{$key}[10] ne ''){
			return"$configfwdfw{$key}[8]";
		}elsif($configfwdfw{$key}[9] ne ''){
			return"$configfwdfw{$key}[8]";
		}else{
			return "$configfwdfw{$key}[8]";
		}
	}elsif($configfwdfw{$key}[11] eq 'ON' && $SRC_TGT eq ''){
		if ($configfwdfw{$key}[15] ne ''){
			return "$configfwdfw{$key}[12]";
		}elsif($configfwdfw{$key}[13] ne ''){
			return "$configfwdfw{$key}[12]";
		}else{
			return "$configfwdfw{$key}[12]";
		}
	}
}
sub get_port
{
	my $key=shift;
	if ($configfwdfw{$key}[7] eq 'ON' && $SRC_TGT eq 'SRC'){
		if ($configfwdfw{$key}[10] ne ''){
			return "--sport $configfwdfw{$key}[10] ";
		}elsif($configfwdfw{$key}[9] ne ''){
			return "--icmp-type $configfwdfw{$key}[9] ";
		}
	}elsif($configfwdfw{$key}[11] eq 'ON' && $SRC_TGT eq ''){
		if ($configfwdfw{$key}[15] ne ''){
			return "--dport $configfwdfw{$key}[15] ";
		}elsif($configfwdfw{$key}[13] ne ''){
			return "--icmp-type $configfwdfw{$key}[13] ";
		}
	}
}
sub get_ipsec_net_ip
{
	my $val=shift;
	my $field=shift;
	foreach my $key (sort keys %ipsecconf){
		if($ipsecconf{$key}[1] eq $val){
			return $ipsecconf{$key}[$field];
		}
	}
}
sub get_ipsec_host_ip
{
	my $val=shift;
	my $field=shift;
	foreach my $key (sort keys %ipsecconf){
		if($ipsecconf{$key}[1] eq $val){
			return $ipsecconf{$key}[$field];
		}
	}
}
sub get_ovpn_n2n_ip
{
	my $val=shift;
	my $field=shift;
	foreach my $key (sort keys %ccdhost){
		if($ccdhost{$key}[1] eq $val){
			return $ccdhost{$key}[$field];
		}
	}
}
sub get_ovpn_host_ip
{
	my $val=shift;
	my $field=shift;
	foreach my $key (sort keys %ccdhost){
		if($ccdhost{$key}[1] eq $val){
			return $ccdhost{$key}[$field];
		}
	}
}
sub get_ovpn_net_ip
{
	my $val=shift;
	my $field=shift;
	foreach my $key (sort keys %ccdnet){
		if($ccdnet{$key}[0] eq $val){
			return $ccdnet{$key}[$field];
		}
	}
}
sub get_grp_ip
{
	my $val=shift;
	my $src=shift;
	foreach my $key (sort keys %customgrp){
		if ($customgrp{$key}[0] eq $val){
			&get_address($customgrp{$key}[3],$src);
		}
	}		
	
}
sub get_std_net_ip
{
	my $val=shift;
	if ($val eq 'ALL'){
		return "0.0.0.0/0.0.0.0";
	}elsif($val eq 'GREEN'){
		return "$netsettings{'GREEN_NETADDRESS'}/$netsettings{'GREEN_NETMASK'}";
	}elsif($val eq 'ORANGE'){
		return "$netsettings{'ORANGE_NETADDRESS'}/$netsettings{'ORANGE_NETMASK'}";
	}elsif($val eq 'BLUE'){
		return "$netsettings{'BLUE_NETADDRESS'}/$netsettings{'BLUE_NETMASK'}";
	}elsif($val =~ /OpenVPN/i){
		return "$ovpnSettings{'DOVPN_SUBNET'}";
	}elsif($val =~ /IPsec/i){
		return "$ipsecsettings{'RW_NET'}";
	}
}
sub get_net_ip
{
	my $val=shift;
	foreach my $key (sort keys %customnetwork){
		if($customnetwork{$key}[0] eq $val){
			return "$customnetwork{$key}[1]/$customnetwork{$key}[2]";
		}  
	}
}
sub get_host_ip
{
	my $val=shift;
	my $src=shift;
	foreach my $key (sort keys %customhost){
		if($customhost{$key}[0] eq $val){
			if ($customhost{$key}[1] eq 'mac' && $src eq 'src'){
			return "-m mac --mac-source $customhost{$key}[2]";
			}elsif($customhost{$key}[1] eq 'ip' && $src eq 'src'){
				return "$customhost{$key}[2]";
			}elsif($customhost{$key}[1] eq 'ip' && $src eq 'tgt'){
				return "$customhost{$key}[2]";
			}elsif($customhost{$key}[1] eq 'mac' && $src eq 'tgt'){
				return "none";
			}
		}  
	}
}
